package com.xc.config;

import com.xc.dao.RealTimeMapper;
import com.xc.dao.StockMapper;
import com.xc.pojo.Stock;
import com.xc.utils.stock.sina.SinaStockApi;
import java.util.List;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;
import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import org.springframework.stereotype.Component;

@Component
public class StockPoll {
    @Resource
    StockMapper stockMapper;

    @Resource
    RealTimeMapper realTimeMapper;

    private ThreadPoolExecutor pool;

    @PostConstruct
    public void initPool() {
        this.pool = new ThreadPoolExecutor(50, 70, 20L, TimeUnit.SECONDS, new ArrayBlockingQueue<>(240));
        this.pool.setRejectedExecutionHandler(new ThreadPoolExecutor.DiscardOldestPolicy());
    }

    public void test(String stockType, Integer stock_num, Integer stock_nums) {
        List<Stock> stockCodes = this.stockMapper.findStockCode(stockType, stock_num, stock_nums);
        System.out.println("stockCodes" + stockCodes.size() + "--stockCodes");
        for (Stock stock : stockCodes) {
            String stockGid = stock.getStockGid();
            String sinaStock = SinaStockApi.getSinaStock("s_" + stockGid);
            String[] arrayOfString = sinaStock.split(",");
            StockTask stockTask = new StockTask();
            stockTask.splits((Object[])arrayOfString);
            stockTask.stockGid(stockGid);
            stockTask.StockPoll(this);
            stockTask.RealTimeMapper(this.realTimeMapper);
            this.pool.submit(stockTask);
        }
    }

    public void z1() {
        test("sz", Integer.valueOf(0), Integer.valueOf(540));
    }

    public void z2() {
        test("sz", Integer.valueOf(540), Integer.valueOf(540));
    }

    public void z3() {
        test("sz", Integer.valueOf(1080), Integer.valueOf(540));
    }

    public void z4() {
        test("sz", Integer.valueOf(1620), Integer.valueOf(539));
    }

    public void h1() {
        test("sh", Integer.valueOf(0), Integer.valueOf(484));
    }

    public void h2() {
        test("sh", Integer.valueOf(484), Integer.valueOf(484));
    }

    public void h3() {
        test("sh", Integer.valueOf(968), Integer.valueOf(485));
    }
}
