package com.xc.controller;

import com.xc.common.ServerResponse;
import com.xc.service.EmailService;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/api/email/"})
public class EmailApiController {

    private static final Logger log = LoggerFactory.getLogger(SmsApiController.class);

    @Autowired
    EmailService emailService;

    //注册用户 邮件发送
    @RequestMapping({"sendRegEmail.do"})
    @ResponseBody
    public ServerResponse sendRegEmail(String emailAdd) {
        if (StringUtils.isBlank(emailAdd)) {
            return ServerResponse.createByErrorMsg("发送失败，邮箱不能为空");
        }
        String code = emailService.sendRegEmail(emailAdd);
        return ServerResponse.createBySuccessMsg("发送成功");
    }

}
