package com.xc.controller;

import com.google.common.base.Strings;
import com.xc.common.CmcPayConfig;
import com.xc.common.ServerResponse;

import com.xc.service.IPayService;

import java.io.IOException;
import java.net.URLDecoder;

import javax.servlet.http.HttpServletRequest;

import javax.servlet.http.HttpServletResponse;

import com.xc.service.IUserRechargeService;
import com.xc.service.IUserService;
import com.xc.utils.pay.CmcPayOuterRequestUtil;
import org.apache.commons.collections.map.LinkedMap;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;

import org.slf4j.LoggerFactory;

import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.stereotype.Controller;

import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/api/pay/"})
public class PayApiController {
    private static final Logger log = LoggerFactory.getLogger(PayApiController.class);

    @Autowired
    IPayService iPayService;

    @Autowired
    IUserService iUserService;

    @Autowired
    IUserRechargeService iUserRechargeService;

    @RequestMapping({"juhe1Notify.do"})
    @ResponseBody
    public void juhe1Notify(HttpServletRequest request, HttpServletResponse response) throws IOException {
        ServerResponse serverResponse = this.iPayService.juhe1Notify(request);
        if (serverResponse.isSuccess()) {
            response.getWriter().write("ok");
            log.info("第一个支付渠道的通知 返回 ok 成功");
        } else {
            log.error("juhe1Notify error Msg = {}", serverResponse.getMsg());
        }
    }

    @RequestMapping({"juhenewpayNotify.do"})
    @ResponseBody
    public void juhenewpayNotify(HttpServletRequest request, HttpServletResponse response) throws IOException {
        System.out.println("============开始回调===============");
        System.out.println(request.getParameter("amount"));
        LinkedMap map = new LinkedMap();
        String out_trade_no = (String) request.getParameter("out_trade_no");
        String amount = (String) request.getParameter("amount");
        String[] arr = out_trade_no.split("_");
        map.put("amount", amount);
        map.put("appid", (String) request.getParameter("appid"));
        //map.put("currency_type", (String) request.getParameter("currency_type"));
        //map.put("goods_name", (String) request.getParameter("goods_name"));
        map.put("out_trade_no", out_trade_no);
        map.put("pay_id", (String) request.getParameter("pay_id"));
        map.put("pay_no", (String) request.getParameter("pay_no"));
        map.put("payment", (String) request.getParameter("payment"));
        map.put("resp_code", (String) request.getParameter("resp_code"));
        map.put("resp_desc", URLDecoder.decode((String) request.getParameter("resp_desc"), "UTF-8"));
        //map.put("sign_type", (String) request.getParameter("sign_type"));
        map.put("tran_amount", (String) request.getParameter("tran_amount"));
        map.put("version", (String) request.getParameter("version"));
        String _sign = CmcPayOuterRequestUtil.getSign(map, CmcPayConfig.KEY);

        System.out.println("resp_code：" + (String) request.getParameter("resp_code"));
        System.out.println("sign：" + (String) request.getParameter("sign"));
        System.out.println("_sign：" + _sign);

        // 表示订单收款【成功】的情况，请根据实际情况自行处理
//        if ("00".equals((String) request.getParameter("resp_code")) && _sign.equals((String) request.getParameter("sign"))) {
        log.info("回调创建订单前map==="+map.toString());
        if ("00".equals((String) request.getParameter("resp_code"))) {
            // 这里编写用户业务逻辑代码，如存储订单状态，自动发货等
            //TODO
            if (amount != null & !StringUtils.isEmpty(amount)) {
                System.out.println("============更新用户金额===============");
                Double aDouble = Double.valueOf(amount);
                Integer integer = aDouble.intValue();
                iUserService.updateUserAmt(aDouble, new Integer(arr[0]));
                iUserRechargeService.createOrder(Integer.valueOf(arr[0]), 1, integer, "2");
            }
            System.out.println("============回调成功并结束===============");
            response.getWriter().println("success");
        } else {
            System.out.println("============回调失败并结束===============");
            response.getWriter().println("error");
        }


//        ServerResponse serverResponse = this.iPayService.juhe1Notify(request);
//        if (serverResponse.isSuccess()) {
//            response.getWriter().write("ok");
//            log.info("第一个支付渠道的通知 返回 ok 成功");
//        } else {
//            log.error("juhe1Notify error Msg = {}", serverResponse.getMsg());
//        }
    }

    @RequestMapping({"flyNotify.do"})
    @ResponseBody
    public void flyNotify(HttpServletRequest request, HttpServletResponse response) throws IOException {
        ServerResponse serverResponse = this.iPayService.flyNotify(request);
        if (serverResponse.isSuccess()) {
            response.getWriter().write("{\"reason\":\"success\"}");
            log.info("fly 支付渠道的通知 返回 success 成功");
        } else {
            log.error("fly notify error Msg = {}", serverResponse.getMsg());
        }
    }
}
