package com.xc.controller;

import com.github.pagehelper.PageInfo;
import com.xc.common.ServerResponse;
import com.xc.pojo.ProtocolInfo;
import com.xc.service.ProtocolService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;


@Controller
@RequestMapping({"/admin/protocol/"})
public class ProtocolAdminController {

    @Autowired
    private ProtocolService protocolService;

    // 获取协议类型
    @RequestMapping({"getProtocolType.do"})
    @ResponseBody
    public ServerResponse getProtocolType() {
        return ServerResponse.createBySuccess(protocolService.getProtocolType());
    }

    // 获取协议详情根据类型
    @RequestMapping({"getProtocolInfoList.do"})
    @ResponseBody
    public ServerResponse<PageInfo> getProtocolInfoList(@RequestParam(required = false) String protocolName, @RequestParam(required = false) String typeId, @RequestParam(value = "pageNum", defaultValue = "1") Integer pageNum, @RequestParam(value = "pageSize", defaultValue = "10") Integer pageSize ) {
        PageInfo pageInfo=protocolService.getProtocolInfoList(protocolName, typeId,pageNum,pageSize);
        return ServerResponse.createBySuccess(pageInfo);
    }
	
    @RequestMapping({"add.do"})
    @ResponseBody
    public ServerResponse add(ProtocolInfo protocolInfo, HttpServletRequest request){
        return this.protocolService.addProtocol(protocolInfo,request);
    }

    @RequestMapping({"update.do"})
    @ResponseBody
    public ServerResponse update(ProtocolInfo protocolInfo,HttpServletRequest request){
        return this.protocolService.updateProtocol(protocolInfo,request);
    }

    @RequestMapping({"delete.do"})
    @ResponseBody
    public Integer delete(Integer id){
        return this.protocolService.deleteProtocol(id);
    }

    @RequestMapping({"selectByid.do"})
    @ResponseBody
    public ProtocolInfo selectByid(Integer id){
        return this.protocolService.selectByid(id);
    }
}
