package com.xc.controller.news;

import com.github.pagehelper.PageInfo;
import com.xc.common.ServerResponse;
import com.xc.pojo.News;
import com.xc.service.NewsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/api/news/")
public class ApiNewsController {

    @Autowired
    NewsService newsService;

    @RequestMapping("list.do")
    public ServerResponse<PageInfo> list(News news, @RequestParam(value = "pageNum", defaultValue = "1") Integer pageNum
            , @RequestParam(value = "pageSize", defaultValue = "10") Integer pageSize) {
        PageInfo pageInfo = newsService.listByNews(news, pageNum, pageSize);
        return ServerResponse.createBySuccess(pageInfo);
    }

    @RequestMapping({"select.do"})
    public ServerResponse select(Integer id) {
        News updateCount = newsService.selectByPrimaryKey(id);
        return ServerResponse.createBySuccess(updateCount);
    }

}
