 package com.xc.controller.protol;

 import com.xc.common.ResponseCode;
 import com.xc.common.ServerResponse;
 import com.xc.pojo.User;
 import com.xc.service.IUserPositionService;
 import javax.servlet.http.HttpServletRequest;

 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.stereotype.Controller;
 import org.springframework.web.bind.annotation.RequestMapping;
 import org.springframework.web.bind.annotation.RequestParam;
 import org.springframework.web.bind.annotation.ResponseBody;

 import java.math.BigDecimal;
 import java.util.List;

 @Controller
 @RequestMapping({"/user/position/"})
 public class UserPositionController {
     private static final Logger log = LoggerFactory.getLogger(UserPositionController.class);

     @Autowired
     IUserPositionService iUserPositionService;

     //查询所有融资平仓/持仓信息
     @RequestMapping({"list.do"})
     @ResponseBody
     public ServerResponse list(HttpServletRequest request,
                                @RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                @RequestParam(value = "state", required = false) Integer state,
                                @RequestParam(value = "stockCode", required = false) String stockCode,
                                @RequestParam(value = "stockSpell", required = false) String stockSpell) {
         return this.iUserPositionService.findMyPositionByCodeAndSpell(stockCode, stockSpell, state, request, pageNum, pageSize);
     }

     //止盈操作
     @RequestMapping({"stopProfitTarget.do"})
     @ResponseBody
     public ServerResponse stopProfitTarget(HttpServletRequest request, @RequestParam(value = "id", required = true) int id,
                                @RequestParam(value = "targetprofit", required = false) BigDecimal targetprofit,
                                @RequestParam(value = "stoploss", required = false) BigDecimal stoploss
                                ) {
         if(null == targetprofit && null == stoploss){
             return ServerResponse.createByError();
         }
         return this.iUserPositionService.stopProfitTarget(id, targetprofit, stoploss, request);
     }

     //平仓操作
     @RequestMapping({"closeOut.do"})
     @ResponseBody
     public ServerResponse closeOut(HttpServletRequest request, @RequestParam(value = "id", required = true) int id, @RequestParam(value = "orderNum", required = false) Integer orderNum) throws Exception {
         return this.iUserPositionService.closeOut(id, orderNum);
     }

     @RequestMapping({"closeOutList.do"})
     @ResponseBody
     public ServerResponse closeOutList(HttpServletRequest request,@RequestParam(value = "list", required = true) List<Integer> list) throws Exception {
         return this.iUserPositionService.closeOutList(list);
     }
	 
     @RequestMapping({"oneKeyCloseOut.do"})
     @ResponseBody
     public ServerResponse oneKeyCloseOut(HttpServletRequest request) throws Exception {
         return this.iUserPositionService.oneKeyCloseOut(request);
     }
 }
