package com.xc.controller.protol;


import com.github.pagehelper.PageInfo;
import com.xc.common.ServerResponse;
import com.xc.pojo.User;
import com.xc.pub.redismessage.service.MessageService;
import com.xc.service.IUserRechargeService;
import com.xc.service.IUserService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;


@Controller
@RequestMapping({"/user/recharge/"})
public class UserRechargeController {
    private static final Logger log = LoggerFactory.getLogger(UserRechargeController.class);

    @Autowired
    IUserRechargeService iUserRechargeService;

    @Autowired
    private MessageService messageService;
    @Autowired
    private IUserService iUserService;

    //分页查询所有充币记录
    @RequestMapping({"list.do"})
    @ResponseBody
    public ServerResponse<PageInfo> list(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum, @RequestParam(value = "pageSize", defaultValue = "10") int pageSize, @RequestParam(value = "payChannel", required = false) String payChannel, @RequestParam(value = "orderStatus", required = false) String orderStatus, HttpServletRequest request) {
        return this.iUserRechargeService.findUserChargeList(payChannel, orderStatus, request, pageNum, pageSize);
    }

    //账户线下充币转账 创建充币订单
    @RequestMapping({"inMoney.do"})
    @ResponseBody
    public ServerResponse inMoney(String amtRMB, String amt, String payType,String orderDesc, HttpServletRequest request) {
        User user = this.iUserService.getCurrentRefreshUser(request);
        messageService.sendTopicMessage(String.format("%s充币了%s", user.getRealName(), amt));
        return this.iUserRechargeService.inMoney(amtRMB, amt, payType,orderDesc , request);
    }
}

