package com.xc.controller.sub;

import com.xc.common.ServerResponse;
import com.xc.pub.redismessage.service.MessageService;
import io.netty.util.internal.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/api/sub/"})
public class SubController {
    @Autowired
    private MessageService messageService;

    @RequestMapping({"getMessage.do"})
    @ResponseBody
    public ServerResponse<String> getMessage(String adminName) {
        if (StringUtil.isNullOrEmpty(adminName)) {
            ServerResponse.createByError();
        }
        return ServerResponse.createBySuccessMsg(messageService.getQueueMessage(adminName));
    }

    @RequestMapping({"addMessage.do"})
    @ResponseBody
    public void addMessage(String message) {
        messageService.sendTopicMessage(message);
    }

}
