package com.xc.controller.websocket;

/**
 * Created by qlm on 2020-12-14.
 */


import javax.websocket.*;
import javax.websocket.server.PathParam;
import javax.websocket.server.ServerEndpoint;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;


@ServerEndpoint(value = "/websocket/{userId}")
public class WebSocketController {

    public static Map<String,Session> map = new HashMap<String,Session>();//根据用户找session

    /**
     * 连接建立成功时调用
     * @param userId 登录用户id
     * @param session  可选的参数。session为与某个客户端的连接会话，需要通过它来给客户端发送数据
     */
    @OnOpen
    public void onOpen(Session session, @PathParam("userId") String userId) {
        String[] a = userId.split("&");

        String mUserId = a[0];
        map.put(mUserId + "",session);       //添加到链接map
        try{
            sendUnreadMsg(session);
        }
        catch (Exception e){
            e.printStackTrace();
        }
    }

    /**
     */
    public static void sendUnreadMsg(Session session){
            synchronized(session){
                if(session.isOpen()){
                    try {
                        System.out.println("连接成功");
                        session.getBasicRemote().sendText("连接成功啦");
                    }catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
    }


    /**
     * 连接关闭调用的方法
     */
    @OnClose
    public void onClose(Session session){
        if(map.containsValue(session)){
            for (Entry<String, Session> entry : map.entrySet()){
                if(entry.getValue().equals(session)){
                    map.remove(entry.getKey());
                    break;
                }
            }
        }
    }

    /**
     * 发生错误时调用
     * @param session
     * @param error
     */
    @OnError
    public void onError(Session session, Throwable error){
        if(map.containsValue(session)){
            for (Entry<String, Session> entry : map.entrySet()) {
                if(entry.getValue().equals(session)){
                    map.remove(entry.getKey());
                    break;
                }
            }
        }
        error.printStackTrace();
    }

    /**
     * 消息发送时调用
     * @param requestJson
     * @param session
     */
    @OnMessage
    public void onMessage(String requestJson, Session session) {
        Date date=new Date();
        SimpleDateFormat f = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        System.out.println("啦啦啦"+f.format(date));

    }


    /**
     */
    public void sendSysMsg(String userid, String xMessage) {

        try {
            if ("all".equals(userid)) {
                for(String key:map.keySet()){
                    Session session = map.get(key);
                    if(session!=null){
                        session.getBasicRemote().sendText(xMessage);
                    }
                }
            }
        } catch (IOException e) {
            e.printStackTrace();

        }
    }

}