package com.xc.pub.redismessage.listener;

import com.xc.pub.redismessage.service.MessageService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.connection.Message;
import org.springframework.data.redis.connection.MessageListener;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;


@Component
public class RedisMessageListener implements MessageListener {

    @Autowired
    private MessageService messageService;

    private static Logger logger = LoggerFactory.getLogger(RedisMessageListener.class);

    @Autowired
    private RedisTemplate<String, String> redisTemplate;

    /**
     * 处理订阅消息
     *
     * @param message
     * @param bytes
     */
    @Override
    public void onMessage(Message message, byte[] bytes) {
        // 请使用valueSerializer
        byte[] body = message.getBody();
        byte[] channel = message.getChannel();

        String msgContent = (String) redisTemplate.getValueSerializer().deserialize(body);

        String topic = redisTemplate.getStringSerializer().deserialize(channel);

        //订阅消息进入队列
        messageService.sendQueueMessage(msgContent);

        logger.info("redis--topic:" + topic + "  body:" + msgContent);
    }


    /**
     * 处理消息队列消息
     */
    //@PostConstruct
    public void messageListener() {
        new Thread(() -> {
            while (true) {
               // messageService.dealMsg();
            }
        }, "消息监听任务线程").start();
    }
}
