package com.xc.pub.redismessage.service;

import com.xc.dao.SiteAdminMapper;
import com.xc.pub.redismessage.util.RedisUtil;
import com.xc.pub.redismessage.vo.AdminVo;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.concurrent.TimeUnit;


@Service
public class MessageService {

    private static Logger logger = LoggerFactory.getLogger(MessageService.class);
    @Autowired
    private RedisTemplate<String, String> redisTemplate;

    @Autowired
    private RedisUtil redisUtil;

    @Value("channel01")
    private String channelName;

    @Value("queuename01")
    private String queueName;
    @Autowired
    SiteAdminMapper siteAdminMapper;

    /**
     * redis发布消息
     *
     * @param message
     */
    public void sendTopicMessage(String message) {
        redisTemplate.convertAndSend(channelName, message);
    }

    /**
     * 处理redis消息队列
     */
    public String getQueueMessage(String adminName) {
        if (null == adminName) {
            return "no_data";
        }
        String message = redisUtil.rightPop(String.format("%s_%s", queueName, adminName), 1, TimeUnit.SECONDS);
        if (null == message) {
            // logger.info("redis--queue:" + queueName + "  body:" + message);
            message = "no_data";
        }
        return message;
    }

    /**
     * @param message
     */
    public void sendQueueMessage(String message) {
        for (AdminVo adminVo : siteAdminMapper.listAll()) {
            redisUtil.leftPush(String.format("%s_%s", queueName, adminVo.getAdminName()), message);
        }
    }
}
