package com.xc.service;

import com.xc.pojo.HistoryIndex;
import com.xc.pojo.Quote;
import com.xc.pojo.RealTimeIndex;
import com.xc.vo.index.IndexConfigVo;
import com.xc.vo.index.SymbolInfoVo;
import com.xc.vo.index.SymbolVo;

import java.util.Date;
import java.util.List;

public interface IndexApiService {

    /**
     * 获取配置
     *
     * @return
     */
    IndexConfigVo getConfig();

    /**
     * 获取商品集合
     *
     * @return
     */
    SymbolInfoVo getSymbolInfo();

    SymbolVo getSymbols(String symbol);

    HistoryIndex getHistoryNew(String symbol, String resolution, Long from, Long to);

    /**
     * 根据货币类型和时间查找数据
     *
     * @param indexCode
     * @param time
     * @return
     */
//    RealTimeIndex getRealTimeData(String indexCode, Date time);

    /**
     * 根据货币类型和时间查找数据
     *
     * @param indexCode
     * @param time
     * @return
     */
//    List<RealTimeIndex> getHistData(String indexCode, Date time);


    /**
     * 获取所有的报价
     *
     * @param symbols
     * @return
     */
    List<Quote> getQuotes(String symbols);

}
