package com.xc.service.impl;

import com.xc.common.ServerResponse;
import com.xc.dao.SiteInfoMapper;
import com.xc.dao.SiteSmsLogMapper;
import com.xc.pojo.SiteInfo;
import com.xc.pojo.SiteSmsLog;
import com.xc.service.EmailService;
import com.xc.utils.DateTimeUtil;
import com.xc.utils.email.MailSender;
import com.xc.utils.redis.RedisShardedPoolUtils;
import org.apache.commons.lang3.RandomStringUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class EmailServiceImpl  implements EmailService {

    @Autowired
    SiteSmsLogMapper siteSmsLogMapper;

    @Autowired
    SiteInfoMapper siteInfoMapper;

    @Override
    public String sendRegEmail(String emailAdd){
        String yzmCode = RandomStringUtils.randomNumeric(4);
        String str = "您的注册验证码为：" + yzmCode;
        try {
            SiteInfo siteInfo = siteInfoMapper.selectOne();
            (new MailSender.Builder(siteInfo.getSiteEmailHost(),siteInfo.getSiteEmailProtocol() , siteInfo.getSiteEmailSubject() ,siteInfo.getSiteEmailFrom(), siteInfo.getSiteEmailPassword(), str , emailAdd)).send();
            String keys = "AliyunSmsCode:" + emailAdd;
            RedisShardedPoolUtils.setEx(keys, yzmCode, 5400);
            if (!StringUtils.isEmpty(yzmCode)) {
                SiteSmsLog siteSmsLog = new SiteSmsLog();
                siteSmsLog.setSmsPhone(emailAdd);
                siteSmsLog.setSmsTitle("注册验证码");
                siteSmsLog.setSmsCnt(yzmCode);
                siteSmsLog.setSmsStatus(0);
                siteSmsLog.setSmsTemplate("字段无用");
                siteSmsLog.setAddTime(DateTimeUtil.getCurrentDate());
                siteSmsLogMapper.insert(siteSmsLog);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return yzmCode;
    }
}
