package com.xc.service.impl;

import com.xc.common.ServerResponse;
import com.xc.dao.SiteFuturesSettingMapper;
import com.xc.dao.SiteIndexSettingMapper;
import com.xc.dao.SiteProductMapper;
import com.xc.dao.SiteSettingMapper;
import com.xc.pojo.*;
import com.xc.service.ISiteProductService;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("iSiteProductService")
public class SiteProductServiceImpl
        implements ISiteProductService {
    private static final Logger log = LoggerFactory.getLogger(SiteProductServiceImpl.class);

    @Autowired
    SiteProductMapper siteProductMapper;
    @Autowired
    SiteFuturesSettingMapper siteFuturesSettingMapper;
    @Autowired
    SiteIndexSettingMapper siteIndexSettingMapper;
    @Autowired
    SiteSettingMapper siteSettingMapper;

    public ServerResponse update(SiteProduct siteProduct) {
        if (siteProduct.getId() == null) {
            return ServerResponse.createByErrorMsg("修改id不能为空");
        }
        SiteProduct dbproduct = this.siteProductMapper.selectByPrimaryKey(siteProduct.getId());
        if (dbproduct == null) {
            return ServerResponse.createByErrorMsg("不存在产品设置记录");
        }

        int updateCount = this.siteProductMapper.updateByPrimaryKeySelective(siteProduct);
        if (updateCount > 0) {
            return ServerResponse.createBySuccessMsg("修改成功");
        }
        return ServerResponse.createByErrorMsg("修改失败");
    }

    public SiteProduct getProductSetting() {
        SiteProduct siteProduct = null;
        List list = this.siteProductMapper.findAllSiteSetting();
        if (list.size() > 0) {
            siteProduct = (SiteProduct)list.get(0);
            //siteProduct.setStockDisplay(true);
            siteProduct.setKcStockDisplay(false);
            siteProduct.setIndexDisplay(false);
            siteProduct.setFuturesDisplay(false);
        }
        return siteProduct;
    }

    @Override
    public forceStopPercent getRateall() {
        forceStopPercent forceStopPercent=new forceStopPercent();
        SiteSetting siteSetting=null;
        SiteIndexSetting siteIndexSetting=null;
        SiteFuturesSetting siteFuturesSetting=null;
        List list=this.siteSettingMapper.findAllSiteSetting();
        if (list.size() > 0) {
            siteSetting=(SiteSetting) list.get(0);
        }
        List list2=this.siteIndexSettingMapper.selectAllSiteIndexSetting();
        if (list2.size()>0){
            siteIndexSetting=(SiteIndexSetting)list2.get(0);
        }
        List list3=this.siteFuturesSettingMapper.selectAllSiteSetting();
        if (list3.size()>0){
            siteFuturesSetting=(SiteFuturesSetting)list3.get(0);
        }
        forceStopPercent.setStockrate(siteSetting.getForceStopPercent());
        forceStopPercent.setIndexrate(siteIndexSetting.getForceSellPercent());
        forceStopPercent.setFuturesrate(siteFuturesSetting.getForceSellPercent());
        return forceStopPercent;
    }
}
