package com.xc.utils.pay;


import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Base64;
import java.util.Date;

import com.alibaba.fastjson.JSON;
import com.xc.common.CmcPayConfig;
import com.xc.controller.protol.UserPayController;
import org.apache.commons.collections.map.LinkedMap;
import org.apache.commons.lang.math.RandomUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


/**
 * Created by xieyuxing on 2017/9/22.
 */

public class CmcPayTool {
    private static final Logger log = LoggerFactory.getLogger(UserPayController.class);

    /*Cmc支付提交*/
    public static String submitOrder(String amount, String orderid, String pay_id) throws Exception {
        if (orderid==null||orderid.trim().equals("")) orderid= "OF"+new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
        LinkedMap params=new LinkedMap();
        params.put("appid", CmcPayConfig.UID);
        params.put("pay_id", pay_id);
        params.put("version", "1.1");
        Double d= Double.parseDouble(amount); 
        DecimalFormat df = new DecimalFormat("0.00");
        String s = df.format(d);
        params.put("total_fee", s);
        params.put("return_url", CmcPayConfig.RETURN_URL);
        log.info("return_url"+CmcPayConfig.RETURN_URL);
        params.put("notify_url", CmcPayConfig.NOTIFY_URL);
        log.info("notify_url"+CmcPayConfig.NOTIFY_URL);

        Base64.Encoder encoder = Base64.getEncoder();
        params.put("out_trade_no", orderid);
        log.info("提交支付订单key="+CmcPayConfig.KEY);
        String _sign=  CmcPayOuterRequestUtil.getSign(params, CmcPayConfig.KEY);
        params.put("sign", _sign);
        //token是用户自定义的字段，千应服务器会原址返回，请自定义此字段
        //插入订单
		// 保存订单 为未支付
        try {
            String par = JSON.toJSONString(params).toString();
            log.info("提交支付订单参数="+par);
            String urlWithParams=CmcPayOuterRequestUtil.post(CmcPayConfig.URL,params);
            return urlWithParams;
            //response.sendRedirect(urlWithParams);
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }
}