//package com.xc.utils.redis;
//
//import com.google.gson.Gson;
//import lombok.extern.slf4j.Slf4j;
//import org.aspectj.lang.ProceedingJoinPoint;
//import org.aspectj.lang.annotation.Around;
//import org.aspectj.lang.annotation.Aspect;
//import org.aspectj.lang.annotation.Pointcut;
//import org.aspectj.lang.reflect.MethodSignature;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.stereotype.Component;
//
//import java.util.concurrent.locks.Lock;
//import java.util.concurrent.locks.ReentrantLock;
//
//@Slf4j
//@Aspect
//@Component
//public class RedisCacheAspect {
//
//    @Pointcut("@annotation(RedisCache)")
//    public void setJoinPoint(){}
//
//    //环绕通知:可以获取返回值
//    @Around(value = "setJoinPoint()")
//    public Object aroundMethod(ProceedingJoinPoint proceedingJoinPoint){
//        Object result = null;
//        try {
//            //前置通知
////            log.info("前置通知");
//            //获取连接点参数
//            Object[] args = proceedingJoinPoint.getArgs();
////            log.info("连接点参数"+args);
//            //获取连接点方法
//            MethodSignature signature = (MethodSignature) proceedingJoinPoint.getSignature();
//            //获取方法上的注解
//            RedisCache annotation = signature.getMethod().getAnnotation(RedisCache.class);
//
//            //如果没有获取到注解直接返回方法执行结果
//            if (annotation == null){
//                return proceedingJoinPoint.proceed(args);
//            }
//            String preFix = annotation.prefix();
//            int timeout = annotation.timeout();
//            int method = annotation.method();
////            Class clazz = annotation.clazz();
//
//            //获取注解prefix值（redis的前缀名）
//            StringBuilder prefix = new StringBuilder(proceedingJoinPoint.getSignature().getName()+":"+preFix);
//            //将前缀名和参数进行累加，参数是具体的ID值
//            if (args!=null){
//                for (Object arg : args) {
//                    prefix.append(arg.toString());
//                }
//            }
////            log.info("将前缀名和参数进行累加"+prefix);
//
//            if (method == 1){
//                //先进行查找判断redis里是否有这条数据，如果有就直接返回redis里的数据
////                Object redisData = RedisShardedPoolUtils.getRedisData(prefix.toString() , signature);
//                Object redisData = RedisShardedPoolUtils.getObject(prefix.toString() , signature.getReturnType());
//                if (null!=redisData){
////                    log.info("有缓存"+redisData);
//                    return redisData;
//                }else {
//                    //没有在缓存中查到数据，需要将数据存入缓存
//                    Lock lock = new ReentrantLock();
//                    lock.lock();
//                    try {
//                        //进行第二次判断
//                        if (null == redisData){
//                            result = proceedingJoinPoint.proceed(args);
//                            Gson gson = new Gson();
//                            //缓存至Redis key策略：需要缓存的对象的 全类名-id，如：entity.User-1
//                            //将数据以json字符串形式存入redis，redis数据类型为String类型
//                            if (timeout <= 0){
////                                RedisShardedPoolUtils.saveCache(prefix.toString(),result);
//                                RedisShardedPoolUtils.setObject(prefix.toString(),result);
//                            }else {
//                                RedisShardedPoolUtils.setEx(prefix.toString() , gson.toJson(result) , timeout);
//                            }
//                            redisData=result;
////                            log.info("写缓存"+redisData);
//                        }
//                        //返回通知
//                        return redisData;
//                    }catch (Exception e){
//                        //e.printStackTrace();
//                    }finally {
//                        lock.unlock();
//                    }
//                }
//            }else if (method == 2){
//
//            }else if (method == -1 || method == 0){
//                RedisShardedPoolUtils.del(prefix.toString());
//            }
//
//        } catch (Throwable e) {
//            //异常通知
//            log.info("异常通知"+e);
//        }finally {
//            //后置通知
////            log.info("后置通知");
//        }
//        return result;
//    }
//
//}