package com.xc.utils.smsUtil;

import com.xc.common.ServerResponse;
import com.xc.controller.SmsApiController;
import com.xc.dao.SiteSmsLogMapper;
import com.xc.pojo.SiteSmsLog;
import com.xc.service.ISiteSmsLogService;
import com.xc.service.impl.SiteSmsLogServiceImpl;
import com.xc.utils.DateTimeUtil;
import com.xc.utils.PropertiesUtil;
import com.xc.utils.pay.CmcPayOuterRequestUtil;
import com.xc.utils.redis.RedisShardedPoolUtils;
import net.sf.json.JSONObject;
import org.apache.commons.lang3.RandomStringUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

public class smsUtil {
    private static final Logger log = LoggerFactory.getLogger(SmsApiController.class);

    /*【网建短信模板】*/
    public String sendSMS(String telephone) {
        String smsType = PropertiesUtil.getProperty("sms.type");
        if(StringUtils.isBlank(smsType) || "wj".equals(smsType)) {
            String code = RandomStringUtils.randomNumeric(4);
            CmcPayOuterRequestUtil requestUtil = new CmcPayOuterRequestUtil();
            String uid = PropertiesUtil.getProperty("wj.sms.uid");
            String key = PropertiesUtil.getProperty("wj.sms.key");
            String coding = PropertiesUtil.getProperty("wj.sms.coding");
            String url = "http://" + coding + ".api.smschinese.cn/?Uid=" + uid + "&Key=" + key + "&smsMob=" + telephone + "&smsText=您正在申请手机注册，验证码为：" + code + "，5分钟内有效！";
            log.info("smsurl" + url);
            String result = requestUtil.sendGet(url);
            log.info("smsresult=" + result + "==code=" + code);
            if (Integer.valueOf(result) < 0) {
                return result;
            } else {
                String keys = "AliyunSmsCode:" + telephone;
                RedisShardedPoolUtils.setEx(keys, code, 5400);
                return code;
            }
        } else {
            return sendSMSJh(telephone);
        }
    }

    /*【聚合短信模板】*/
    public String sendSMSJh(String telephone) {
        String code = RandomStringUtils.randomNumeric(4);
        CmcPayOuterRequestUtil requestUtil = new CmcPayOuterRequestUtil();
        /*【短信模板】*/
        String result =null;
        String url ="http://v.juhe.cn/sms/send";//请求接口地址
        Map params = new HashMap();//请求参数
        params.put("mobile",telephone);//接受短信的用户手机号码
        params.put("tpl_id",PropertiesUtil.getProperty("jh.sms.uid"));//您申请的短信模板ID，根据实际情况修改
        params.put("tpl_value","#code#="+code);//您设置的模板变量，根据实际情况修改
        params.put("key",PropertiesUtil.getProperty("jh.sms.key"));//应用APPKEY(应用详细页查询)
        try {
            url = url+"?"+urlencode(params);
            log.info("smsurl"+url);
            result = requestUtil.sendGet(url);
            log.info("smsresult="+result+"==code="+code);
            JSONObject object = JSONObject.fromObject(result);
            if(object.getInt("error_code")==0){
                System.out.println(object.get("result"));
                return code;
            }else{
                System.out.println(object.get("error_code")+":"+object.get("reason"));
                return object.get("error_code").toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
    }

    //将map型转为请求参数型
    public static String urlencode(Map<String,String> data) {
        StringBuilder sb = new StringBuilder();
        for (Map.Entry i : data.entrySet()) {
            try {
                sb.append(i.getKey()).append("=").append(URLEncoder.encode(i.getValue()+"","UTF-8")).append("&");
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
        }
        return sb.toString();
    }

}
