package com.xc.utils.stock;


import java.text.SimpleDateFormat;

import java.util.Calendar;

import java.util.Date;

import org.apache.commons.lang3.StringUtils;

import org.slf4j.Logger;

import org.slf4j.LoggerFactory;


public class BuyAndSellUtils {

    private static final Logger log = LoggerFactory.getLogger(BuyAndSellUtils.class);


    public static boolean isTransTime(String begin_time, String end_time) throws Exception {
        if (StringUtils.isBlank(begin_time) || StringUtils.isBlank(end_time)) {
            return false;
        }
        Date nowDate = new Date();
//        if (!isWorkDay(nowDate)) {
//            return false;
//        }
        SimpleDateFormat df = new SimpleDateFormat("HH:mm");
        Date now = null;
        Date beginTime = null;
        Date endTime = null;
        try {
            now = df.parse(df.format(nowDate));
            beginTime = df.parse(begin_time);
            endTime = df.parse(end_time);
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
        Boolean flag = Boolean.valueOf(belongCalendar(now, beginTime, endTime));
        return flag.booleanValue();
    }

    private static boolean istimes(String startTime, String endTime, String nowTime){
        int startInt = Integer.valueOf(startTime);
        int endInt = Integer.valueOf(endTime);
        int nowInt = Integer.valueOf(nowTime);
        if(startInt>endInt){
            //+24小时
            endInt  = endInt + 2400;
        }
        //然后判断
        if(nowInt>startInt&&nowInt<endInt){
            return true;
        }else if(nowInt<startInt){
            nowInt = nowInt +2400;
            if(nowInt>startInt&&nowInt<endInt){
                return true;
            }
        }
        return false;
    }
	
    public static boolean belongCalendar(Date nowTime, Date beginTime, Date endTime) {
        Calendar date = Calendar.getInstance();
        date.setTime(nowTime);
        Calendar begin = Calendar.getInstance();
        begin.setTime(beginTime);
        Calendar end = Calendar.getInstance();
        end.setTime(endTime);
        if(end.before(begin)){
            // 结尾时间在开始时间之前 表示为第二天
            end.add(Calendar.DATE, 1);
        }
        if (date.after(begin) && date.before(end)) {
            return true;
        }
        date.add(Calendar.DATE, 1);
        if(date.after(begin) && date.before(end)){
            return true;
        }
        return false;
    }

    public static boolean belongCalendar(Long nowTime, Long beginTime, Long endTime) {
        Date dateTemp = new Date(Long.valueOf(nowTime));
        Calendar date = Calendar.getInstance();
        date.setTime(dateTemp);
        Calendar begin = Calendar.getInstance();
        begin.setTime(new Date(beginTime * 1000));
        Calendar end = Calendar.getInstance();
        end.setTime(new Date(endTime * 1000));
        if(end.before(begin)){
            // 结尾时间在开始时间之前 表示为第二天
            end.add(Calendar.DATE, 1);
        }
        if (date.after(begin) && date.before(end)) {
            return true;
        }
        date.add(Calendar.DATE, 1);
        if(date.after(begin) && date.before(end)){
            return true;
        }
        return false;
    }

    public static boolean isWorkDay(Date currentDate) throws Exception {

        Calendar cal = Calendar.getInstance();

        cal.setTime(currentDate);

        if (cal.get(7) == 7 || cal.get(7) == 1) {

            return false;

        }

        return true;

    }


    public static void main(String[] args) {
        try {
            SimpleDateFormat df = new SimpleDateFormat("HH:mm");
            Date now = null;
            Date beginTime = null;
            Date endTime = null;
//            now = df.parse(df.format(new Date()));
            now = df.parse("15:00");
            beginTime = df.parse("13:00");
            endTime = df.parse("14:00");
//            System.out.println(istimes(String.valueOf(beginTime.getTime()), String.valueOf(endTime.getTime()), String.valueOf((now.getTime()))));

            System.out.println(belongCalendar(now, beginTime, endTime));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
