package com.xc.utils.task.index;

import com.xc.service.IUserPositionService;
import com.xc.service.InitStockListService;
import com.xc.utils.DateTimeUtil;
import com.xc.utils.thread.ThreadUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.Date;

@Component
public class DemurrageIndexTask {
    private static final Logger log = LoggerFactory.getLogger(DemurrageIndexTask.class);

    @Autowired
    IUserPositionService iUserPositionService;

    @Autowired
    InitStockListService initStockListService;

    // 星期一到星期五的0点触发
//    @Scheduled(cron = "0 0 0 ? * MON-FRI")
    // 每天0点触发
    @Scheduled(cron = "0 0 0 * * ?")
    public void calcDemurrage() {
        log.info("=====定时任务===计算延期费，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
        doTask();
        log.info("=====定时任务===计算延期费，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
    }

    @Scheduled(cron = "1 0 0 * * ?")
    public void initStockToRedis() {
        initStockListService.initStockToRedis();
    }


    private void doTask() {
        ThreadUtil.executeInThread(obj -> {
            iUserPositionService.calcDemurrage();
        });
    }



}
