package com.xc.utils.task.index;

import com.xc.service.IUserService;
import com.xc.utils.DateTimeUtil;
import java.util.Date;
import com.xc.utils.thread.ThreadUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

@Component
public class ForceSellTask {

    private static final Logger log = LoggerFactory.getLogger(ForceSellTask.class);

    @Autowired
    IUserService iUserService;

    /*用户持仓单定时*/
//    @Scheduled(cron = "0 0/3 9-23 ? * MON-FRI")
    @Scheduled(cron = "*/3 * * * * ?")
    public void banlanceUserPositionTaskV1() {
        boolean am = true;
        boolean pm = true;
        if (am || pm) {
            log.info("=====扫描爆仓任务，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
            dotask();
            log.info("=====扫描爆仓任务，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
        } else {
            log.info("当前时间不为周一至周五，或者不在交易时间内，不执行（爆仓）定时任务");
        }
    }

    public void dotask() {
        ThreadUtil.executeInThread(obj -> {
            this.iUserService.ForceSellTask();
        });
    }

}
