package com.xc.utils.task.index;

import com.xc.service.IUserPositionService;
import com.xc.utils.DateTimeUtil;
import com.xc.utils.stock.BuyAndSellUtils;

import com.xc.utils.thread.ThreadUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.Date;

@Component
public class StopProfitTargetTask {
    private static final Logger log = LoggerFactory.getLogger(StopProfitTargetTask.class);

//    private static final String am_begin = "9:30";
//
//    private static final String am_end = "11:30";
//
//    private static final String pm_begin = "13:00";
//
//    private static final String pm_end = "23:00";

    @Autowired
    IUserPositionService iUserPositionService;

    // 星期一到星期五的每天9点到15点触发 每3分钟触发一次
//    @Scheduled(cron = "0 0/3 9-23 ? * MON-FRI")
    @Scheduled(cron = "*/3 * * * * ?")
    public void toEntrust() {
        boolean am = true;
        boolean pm = true;
//        try {
//            // 开市时间要获取DB中的
//            am = BuyAndSellUtils.isTransTime(am_begin, am_end);
//            pm = BuyAndSellUtils.isTransTime(pm_begin, pm_end);
//        } catch (Exception e) {
//            log.error("执行定时任务出错，e = {}", e);
//        }
        if (am || pm) {
            log.info("=====定时任务===计算止盈止损=开始，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
            try {
                doTask();
            } catch (Exception e) {
                log.info("=====定时任务===计算止盈止损==异常" + e);
            }
            log.info("=====定时任务===计算委托==结束，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
        } else {
            log.info("当前时间不为周一至周五，或者不在交易时间内，不执行（止盈止损）定时任务");
        }
    }

    private void doTask() throws Exception {
        ThreadUtil.executeInThread(obj -> {
            try {
                iUserPositionService.toStopProfitTarget();
            } catch (Exception e) {
                e.printStackTrace();
            }
        });
    }
}
