package com.xc.utils.task.stock;

import com.xc.service.NewsService;
import com.xc.utils.thread.ThreadUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class NewsTask {

    @Autowired
    NewsService newsService;

    private static final Integer num = 10;
    private static final Integer start = 0;

    /**
     * 0 0 16 ? * MON-FRI 每天16点 跳过星期六星期天
     * 0 0 0/1 * * ?  每一小时获取一次
     */
    @Scheduled(cron = "0 0 0/12 * * ?")
    public void getNewsApiTaskV1() {
        ThreadUtil.executeInThread(obj -> {
            dotask();
        });
    }

    public void dotask() {
        this.newsService.getApiNews(num,start);
    }

}
