package com.xc.utils.websocket;

import com.alibaba.fastjson.JSONObject;
import com.xc.controller.websocket.WebSocketController;
import com.xc.service.InitStockListService;
import com.xc.vo.stock.StockVO;
import org.apache.commons.lang3.StringUtils;
import org.java_websocket.client.WebSocketClient;
import org.java_websocket.handshake.ServerHandshake;

import java.math.BigDecimal;
import java.net.URI;
import java.util.ArrayList;
import java.util.List;

public class WsClient extends WebSocketClient {

    private static WsClient instance ;

    static InitStockListService initStockListServiceBiz;
    /**
     * 单例
     */
    public static WsClient getInstance(InitStockListService initStockListService) {
        initStockListServiceBiz=initStockListService;
        return instance;
    }

    public  WsClient(URI serverUri) {
        super(serverUri);
    }

    @Override
    public void onOpen(ServerHandshake arg0) {
        System.out.println(arg0);
        System.out.println("握手成功");

    }

    @Override
    public void onClose(int arg0, String arg1, boolean arg2) {
        System.out.println("连接关闭");
    }

    @Override
    public void onError(Exception arg0) {

        System.out.println(arg0.toString());
    }


    /**
     * 订阅返回的数据
     * @param arg0
     */
    @Override
    public void onMessage(String arg0) {
        try {
            if(StringUtils.isNotBlank(arg0)){
                // 存储信息至redis
                JSONObject parse = (JSONObject) JSONObject.parse(arg0);
                StockVO stockVO = new StockVO();
                stockVO.setId(parse.getInteger("id"));
                stockVO.setName(parse.getString("name"));
                stockVO.setCode(parse.getString("code"));
                stockVO.setSpell(parse.getString("spell"));
                stockVO.setGid(parse.getString("gid"));
                stockVO.setNowPrice(parse.get("nowPrice")+"");
                stockVO.setHcrate(new BigDecimal(parse.get("hcrate")+""));
                stockVO.setToday_max(parse.get("today_max")+"");
                stockVO.setToday_min(parse.get("today_min")+"");
                stockVO.setBusiness_balance(parse.get("business_balance")+"");
                stockVO.setBusiness_amount(parse.get("business_amount")+"");
                stockVO.setPreclose_px(parse.get("preclose")+"");
                stockVO.setOpen_px(parse.get("open")+"");
                stockVO.setTransState(parse.getInteger("transState"));
                stockVO.setDepositAmt(parse.getInteger("depositAmt"));
                stockVO.setMinImg(parse.getString("minImg"));
                stockVO.setDayImg(parse.getString("dayImg"));
                stockVO.setWeekImg(parse.getString("weekImg"));
                stockVO.setMonthImg(parse.getString("monthImg"));
                stockVO.setChange(parse.get("change")+"");
                List<StockVO> stockVOList = new ArrayList<>();
                stockVOList.add(stockVO);
                initStockListServiceBiz.updateListInfo(stockVOList);
                initStockListServiceBiz.updateInfo(stockVO);
                // 处理数据 并 推送给 客户
                new WebSocketController().sendSysMsg("all",arg0);
            }
        }catch (Exception e){

        }

    }

    public void closeWebSocket(){
        this.onClose(1,"",true);
    }
}