package com.xc.vo.index;

import lombok.Data;

import java.beans.ConstructorProperties;
import java.io.Serializable;
import java.util.*;

@Data
public class HistoryVo implements Comparable<HistoryVo>, Serializable {
    private Integer id;
    private Long realTime;
    private Double close;
    private Double open;
    private Double high;
    private Double low;
    private Double volume;
    private Long dateOne;
    private Long dateFive;
    private Long dateFifteen;
    private Long dateThirty;
    private Long dateSixty;
    private Long time;

    public HistoryVo() {
    }

    @ConstructorProperties({"id", "realTime", "close", "open", "high", "low", "volume"})
    public HistoryVo(Integer id, Long realTime, Double close, Double open, Double high, Double low, Double volume) {
        this.id = id;
        this.realTime = realTime;
        this.close = close;
        this.open = open;
        this.high = high;
        this.low = low;
        this.volume = volume;
    }

    @Override
    public int compareTo(HistoryVo o) {
        if (this.realTime > o.getRealTime()) {
            return 1;
        } else if (this.realTime == o.getRealTime()) {
            return 0;
        } else {
            return -1;
        }
    }


}
