package com.xc.vo.index;

import lombok.Data;

import java.util.List;

@Data
public class IndexConfigVo {

    private List<Exchange> exchanges;
    // 是否支持商店检索
    private boolean supports_search;

    // 只提供所有商品集合的完整信息，并且无法进行商品搜索或单个商品解析。
    private boolean supports_group_request;

    // 支持的周期数组 例:[1, 15, 240, "D", "6M"]您将在周期中得到 "1 分钟, 15 分钟, 4 小时, 1 天, 6 个月"
    private List<String> supported_resolutions;

    // 是否支持在K线上显示标记
    private boolean supports_marks;

    // 提供服务器时间
    private boolean supports_time;

    private boolean supports_timescale_marks;

    private List<SymbolsType> symbols_types;

    @Data
    public static class Exchange{
        private String desc;
        private String name;
        private String value;
    }

    @Data
    public static class SymbolsType{
        private String name;
        private String value;
    }
}
