package com.xc.dao;

import com.xc.pojo.RealTime;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

public interface RealTimeMapper {
    @Select({"select * from realtime where stockCode=#{stockCode}"})
    List<RealTime> findStock(String paramString);

    @Delete({"DELETE FROM realtime"})
    int deleteStockCode();

    @Insert({"<script>", "insert into realtime (time,volumes,price,rates,amounts,stockCode) values ", "<foreach  collection='areaLists' item='realTime' index='index' separator=','>", "(#{realTime.time},#{realTime.volumes},#{realTime.price},#{realTime.rates},#{realTime.amounts},#{realTime.stockCode})", "</foreach>", "</script>"})
    int insertRealTime(@Param("areaLists") List<RealTime> paramList);
}
