package com.xc.dao;

import com.xc.pojo.UserPosition;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import org.apache.ibatis.annotations.Param;

public interface UserPositionMapper {
  int deleteByPrimaryKey(Integer paramInteger);

  int insert(UserPosition paramUserPosition);

  int insertSelective(UserPosition paramUserPosition);

  UserPosition selectByPrimaryKey(Integer paramInteger);

  UserPosition selectByPrimaryKeyAndStatus(Integer paramInteger);

  int updateByPrimaryKeySelective(UserPosition paramUserPosition);

  int updateByPrimaryKey(UserPosition paramUserPosition);

  UserPosition findPositionBySn(String paramString);

  UserPosition findPositionById(int id);

  List<UserPosition> findMyPositionByCodeAndSpell(@Param("uid") Integer paramInteger1, @Param("stockCode") String paramString1, @Param("stockSpell") String paramString2, @Param("state") Integer paramInteger2);

  List findMyPositionAll(@Param("uid") Integer paramInteger1);

  List findPositionByUserIdAndSellIdIsNull(Integer paramInteger);

  List<UserPosition> listByAgent(@Param("positionType") Integer positionType, @Param("state") Integer state, @Param("nickName") String nickName, @Param("searchId") Integer searchId, @Param("positionSn") String positionSn, @Param("beginTime") Date beginTime, @Param("endTime") Date endTime);

  List findAllStayPosition();

  List findDistinctUserIdList();

  int CountPositionNum(@Param("state") Integer paramInteger1, @Param("accountType") Integer paramInteger2);

  BigDecimal CountPositionProfitAndLose();

  BigDecimal CountPositionAllProfitAndLose();

  int deleteByUserId(@Param("userId") Integer paramInteger);

  List findPositionByStockCodeAndTimes(@Param("minuteTimes") Date paramDate, @Param("stockCode") String paramString, @Param("userId") Integer paramInteger);

  Integer findPositionNumByTimes(@Param("beginDate") Date paramDate, @Param("userId") Integer paramInteger);

  List findPositionAmt(@Param("userId")Integer userId,@Param("stockCode")String stockCode);

  List<UserPosition> listByCodeAndState(@Param("stockCode") String stockCode, @Param("state") Integer state,@Param("userId") Integer userId);

  void updateStopProfitTarget(@Param("id")int id, @Param("targetprofit") BigDecimal targetprofit, @Param("stoploss") BigDecimal stoploss);

  List<UserPosition> selectPositionByUserId(@Param("userId") Integer userId);

  List<Integer> selectPositionUserId();

  int selectUserDemurrageSum(@Param("userId") Integer userId);

  void updateOrderStayFee(@Param("userPosition") UserPosition userPosition);

  List<UserPosition> selectPositionByStopProfitTarget();

  Integer selectTodayOrderNum(@Param("stockName") String stockName);

  void updatePositionStatus(@Param("id") Integer id, @Param("buyOrderPrice") BigDecimal buyOrderPrice, @Param("orderTotalPrice") BigDecimal orderTotalPrice);
}
