package com.xc.service;

import com.github.pagehelper.PageInfo;
import com.xc.common.ServerResponse;
import com.xc.pojo.StockIndexDF;
import com.xc.pojo.User;
import com.xc.pojo.UserPosition;
import com.xc.vo.position.PositionVO;

import java.math.BigDecimal;
import java.util.List;
import javax.servlet.http.HttpServletRequest;

public interface IUserPositionService {
    ServerResponse buyEntryOrders(Integer paramInteger1, Integer paramInteger2, Integer paramInteger3, Integer paramInteger4, BigDecimal buyOrderPrice, HttpServletRequest paramHttpServletRequest) throws Exception;

    ServerResponse buy(Integer paramInteger1, Integer paramInteger2, Integer paramInteger3, HttpServletRequest paramHttpServletRequest) throws Exception;

    ServerResponse sell(String paramString, int paramInt) throws Exception;

    ServerResponse lock(Integer paramInteger1, Integer paramInteger2, String paramString);

    ServerResponse del(Integer paramInteger);

    ServerResponse<PageInfo> findMyPositionByCodeAndSpell(String paramString1, String paramString2, Integer paramInteger, HttpServletRequest paramHttpServletRequest, int paramInt1, int paramInt2);

    PositionVO findUserPositionAllProfitAndLose(Integer paramInteger);

    List<UserPosition> findPositionByUserIdAndSellIdIsNull(Integer paramInteger);

    List<UserPosition> findPositionByStockCodeAndTimes(int paramInt, String paramString, Integer paramInteger);

    Integer findPositionNumByTimes(int paramInt, Integer paramInteger);

    ServerResponse listByAgent(Integer paramInteger1, Integer paramInteger2, String paramInteger3, Integer paramInteger4, String paramString1, String paramString2, String paramString3, HttpServletRequest paramHttpServletRequest, int paramInt1, int paramInt2);

    ServerResponse getIncome(Integer paramInteger1, Integer paramInteger2, String paramString1, String paramString2);

    ServerResponse listByAdmin(Integer paramInteger1, Integer paramInteger2, Integer paramInteger3, String paramInteger4, String paramString1, String paramString2, String paramString3, int paramInt1, int paramInt2);

    int CountPositionNum(Integer paramInteger1, Integer paramInteger2);

    BigDecimal CountPositionProfitAndLose();

    BigDecimal CountPositionAllProfitAndLose();

    ServerResponse create(Integer paramInteger1, String paramString1, String paramString2, String paramString3, Integer paramInteger2, Integer paramInteger3, BigDecimal paramInteger4);

    int deleteByUserId(Integer paramInteger);

    void doClosingStayTask();

    ServerResponse closingStayTask(UserPosition paramUserPosition, Integer paramInteger) throws Exception;

    List<Integer> findDistinctUserIdList();

    ServerResponse revoke(Integer positionId, HttpServletRequest paramHttpServletRequest) throws Exception;

    boolean fulfill();

    ServerResponse stopProfitTarget(int id, BigDecimal targetprofit, BigDecimal stoploss, HttpServletRequest request);

    ServerResponse closeOut(int id, Integer orderNum) throws Exception;

    ServerResponse closeOutList(List<Integer> list) throws Exception;

    ServerResponse oneKeyCloseOut(HttpServletRequest request);

    void calcDemurrage();

    void toStopProfitTarget() throws Exception;

//    StockIndexDF getStockIndexDFByDbName(String dbName);

//    String getNowPriceStrByDbName(String dbName);

    Integer getTodayOrderNum(String stockName);
}
